SuperStrict
SeedRnd MilliSecs()	   'Zufallsgenerator in Gang setzen
'------------------------------------------------------------------------------------
Global ASCII_Size%[] = [8,10]   'Rastergroesse von je 8x10 Pixel
'Diesem Raster werden ALLE Zeichenbefehle unterworfen!!!!!!!
'------------------------------------------------------------------------------------
'Das Spielfeldraster soll aus 100 Reihen und 75 Zeilen bestehen:
Global Column%, Row%, CountColumns% = 125, CountRows% = 70
'Die Fenstergroesse entsprechend der Schriftart konfigurieren:
Global ScreenWidth% = (CountColumns+1) * ASCII_Size[0]
Global ScreenHeight% = (CountRows+1) * ASCII_Size[1]
'Graphikfenster erstellen:
AppTitle = "ASCII-Spaceshooter"
Graphics ScreenWidth, ScreenHeight
SetBlend ALPHABLEND
SetClsColor 0,0,24
Cls
Global RasterBlock:TImage = CreateImage(ASCII_Size[0], ASCII_Size[1])
GrabImage RasterBlock, 0, 0
'------------------------------------------------------------------------------------
'Vier Weltraum-Hintergruende zufaellig mit "Sternen" bemalen:
Global StarBackground:TImage[4]
For Local i% = 0 To 3
	Cls
	For Local c:Int = 0 To CountColumns
		For Local r:Int = 0 To CountRows
			If Rand(0,29) = 0 Then
				SetColor Rand(200,255),255,Rand(0,255)	   'zufaellig gelber-weisser Farbton
				SetAlpha Rnd()	   'zufaellig unterschiedliche Helligkeit
				DrawText ".", ASCII_Size[0]*c, ASCII_Size[1]*r - 1
			End If
		Next
	Next
	StarBackground[i] = LoadImage(GrabPixmap(0, 0, ScreenWidth, ScreenHeight))
Next
SetAlpha 1.0
'Nun fehlt noch die Organisation fuer das "Sternenfunkeln" bzw. die Ueberblendung:
Global Background_Nr%[] = [0, 1]	   'die Nummern der beiden aktuellen Hintergruende
Const Background_Blend_Duration% = 1500	'die Dauer der Ueberblendung
Global Background_Blend_Time% = MilliSecs()	 'der Zeitpunkt des letzten Nummerntauschs
'------------------------------------------------------------------------------------
'Nun zur Erstellung des Raumschiffs, zunaechst das Bild:
Global shuttle:TImage = create_ASCII_Image("t/s", [100, 100,255])
'Ferner zur Position (angepasst an das Raster):
Global shuttle_column% = CountColumns/2
Global shuttle_row% = 3*CountRows/4
'Der (naja...) "Raketenschweif"
Global shuttle_fire:TImage[4]
shuttle_fire[0] = create_ASCII_Image("t/f", [255,127,0])
shuttle_fire[1] = create_ASCII_Image("t/f", [180,90,0])
shuttle_fire[2] = create_ASCII_Image("t/f", [128,64,0])
shuttle_fire[3] = create_ASCII_Image("t/f", [64,32,0])
Global shuttle_fire_step%   'fuer die kleine "Pseudo-Animation"
Const shuttle_fire_duration% = 60
Global shuttle_fire_time% = MilliSecs()
Global shuttle_death% = False
Global shuttle_explosion_nr% = -1
Global ActualTime%
Global Highscore%, Points%    '(die Punkte, die man erhalten hat durch Abschuss von Enemies)
Local highscore_file:TStream = ReadFile(".HS")
If highscore_file <> Null Then
	Highscore = ReadInt(highscore_file)
	CloseStream(highscore_file)
End If
'------------------------------------------------------------------------------------
'Die Explosions-Animationsbilder
Global explosion:TImage[10], explosion_frame_duration% = 20
explosion[0] = create_ASCII_Image("t/x0", [255,255,255])
explosion[1] = create_ASCII_Image("t/x1", [255,255,170])
explosion[2] = create_ASCII_Image("t/x2", [255,255,85])
explosion[3] = create_ASCII_Image("t/x3", [255,255,0])
explosion[4] = create_ASCII_Image("t/x4", [255,205,0])
explosion[5] = create_ASCII_Image("t/x5", [255,155,0])
explosion[6] = create_ASCII_Image("t/x6", [255,105,0])
explosion[7] = create_ASCII_Image("t/x7", [255,55,0])
explosion[8] = create_ASCII_Image("t/x8", [255,0,0])
explosion[9] = create_ASCII_Image("t/x9", [255,0,0])
For Local e% = 0 To 9
	MidHandleImage(explosion[e])
Next
'------------------------------------------------------------------------------------
OnEnd(StopSound_and_Save_Highscore)
Function StopSound_and_Save_Highscore()
	StopChannel(MusikChannel)  'komischer Weise scheint das bei Vista notwendig zu sein...
	Local highscore_file:TStream = WriteFile(".HS")
	If highscore_file <> Null Then
		WriteInt(highscore_file, Highscore)
		CloseStream(highscore_file)
	End If
End Function
'------------------------------------------------------------------------------------
'Die Raumschiff-Geschosse als Objekte:
TBullet.image = create_ASCII_Image("t/b", [255,0,0])
Global Bullet:TBullet[CountRows/2+1], shot_Time%, wait_for_next_bullet% = 100, Bullet_Speed% = 10
Type TBullet
	Global image:TImage
	Field row%, column%, time%
	Function build:TBullet(column%, row%)
		Local New_Bullet:TBullet = New TBullet
		New_Bullet.column = column
		New_Bullet.row = row
		Return New_Bullet
	End Function
	Method draw(index%)
		DrawImage image, column*ASCII_Size[0], row*ASCII_Size[1]
		If ActualTime - time > Bullet_Speed Then
			row = row - 1
			time = ActualTime
			If row < -3 Then Bullet[index] = Null
		End If
	End Method
End Type
'------------------------------------------------------------------------------------
Global count_Enemies% = 11  '(= 12)
'------------------------------------------------------------------------------------
'Die Gegner als Objekte:
TEnemy.image[0] = create_ASCII_Image("t/e0", [255,0,255])
TEnemy.image[1] = create_ASCII_Image("t/e1", [0,255,0])
TEnemy.image[2] = create_ASCII_Image("t/e2", [0,255,255])
TEnemy.image[3] = create_ASCII_Image("t/e3", [255,255,0])
Type TEnemy
	Global image:TImage[4]
	Field row%, column%, shape%, color%[], speed%, time%, dead%, explosion_nr%, explosion_time%
	Function build:TEnemy(index%)
		Local New_Enemy:TEnemy = New TEnemy		
		New_Enemy.column = 1.0 * (index+0.5) * CountColumns/(count_Enemies+1)  'in festen Bahnen, damit sich keine Raumschiffe ueberschneiden.
		New_Enemy.row = -Rand(2,CountRows)
		New_Enemy.speed = Rand( 80, 120)
		New_Enemy.shape = Rand(0,3)
		Return New_Enemy
	End Function
	Method draw()
		If dead = True Then
			DrawImage explosion[explosion_nr], column*ASCII_Size[0], row*ASCII_Size[1]
			If ActualTime - explosion_time > explosion_frame_duration Then
				explosion_time = ActualTime
				explosion_nr = explosion_nr + 1
				If explosion_nr = 10 Then
					explosion_nr = 0
					dead = 2
				End If
			End If
		Else
			If dead = False Then
				DrawImage image[shape], column*ASCII_Size[0], row*ASCII_Size[1]
				draw_shuttle_fire(4, column, row-3)
			End If
			If ActualTime - time > speed Then
				row = row + 1
				time = ActualTime
				If row > CountRows+3 Then
					If shuttle_death = False Then
						row = -Rand(2,8)
						'Fluggeschwindigkeit der feindlichen Raumschiffe in Abhaengigkeit von den bereits
						'erreichten Punkten: Ab 2000 Punkten maximaler Speed zwischen 10 und 50
						speed = Rand( 80 - Min(70, 70 * Max(0,Points) / 2000), 120 - Min(70, 70 * Max(0,Points) / 2000))
						shape = Rand(0,3)
						dead = False
						explosion_nr = 0
					End If
				End If
			End If
		End If
	End Method
End Type
Global Enemy:TEnemy[count_Enemies+1]
For Local a% = 0 To count_Enemies
	Enemy[a] = TEnemy.build(a)
Next
'--------------------------------------------------------------------------------------------------------------------------------------------
'Von 'Altlasten' befreien:
SetColor 255,255,255
SetClsColor 0,0,24
Cls
'--------------------------------------------------------------------------------------------------------------------------------------------
'Intro-Infos:
Global IFi:TStream = ReadStream("t/i")
Function dI(x%, y%)
	DrawText ReadLine(Ifi), x, y
End Function 
dI(33*ASCII_Size[0], 8*ASCII_Size[1])
dI(32*ASCII_Size[0], 9*ASCII_Size[1])
DrawImage TEnemy.image[0], 30*ASCII_Size[0], 20*ASCII_Size[1]
dI(40*ASCII_Size[0], 18*ASCII_Size[1])
DrawImage TEnemy.image[1], 30*ASCII_Size[0], 30*ASCII_Size[1]
dI(44*ASCII_Size[0], 30*ASCII_Size[1])
DrawImage TEnemy.image[2], 30*ASCII_Size[0], 41*ASCII_Size[1]
dI(44*ASCII_Size[0], 40*ASCII_Size[1])
DrawImage TEnemy.image[3], 30*ASCII_Size[0], 52*ASCII_Size[1]
dI(40*ASCII_Size[0], 50*ASCII_Size[1])
dI(43*ASCII_Size[0], 52*ASCII_Size[1])
dI(28*ASCII_Size[0], ScreenHeight - 8*ASCII_Size[1])
dI(36*ASCII_Size[0], ScreenHeight - 5*ASCII_Size[1])
Flip
'Die anschliessende Pause nutzen, um unbemerkt alle Sounds zu laden...
Global Snd:TSound[4]
For Local j% = 0 To 3
	Snd[j] = LoadSound("s/" + j + ".ogg")
Next

'--------------------------------------------------------------------------------------------------------------------------------------------
If Not KeyHit(KEY_RETURN) Then WaitKey()
FlushKeys()
Global MusikChannel:TChannel = PlaySound(Snd[0])
'====================================================================================
Repeat
	Cls
	'----------------------------------------------------
	'EINMAL pro Hauptschleife gemessen, brauchen wir die Zeit fuer verschiedenes:
	ActualTime = MilliSecs() 
	'----------------------------------------------------
	Local Blend_Value:Float = Min(1, 1.0 * (ActualTime - Background_Blend_Time) / Background_Blend_Duration)
	SetAlpha 1-Blend_Value
	DrawImage StarBackground[Background_Nr[0]], 0, 0
	SetAlpha Blend_Value
	DrawImage StarBackground[Background_Nr[1]], 0, 0
	If Blend_Value >= 1 Then
		Background_Nr[0] = Background_Nr[1]
		Background_Nr[1] = (Background_Nr[1] + 1) Mod 4
		Background_Blend_Time = ActualTime	
	End If
	SetAlpha 1.0
	'----------------------------------------------------
	'Die feindlichen Raumschiffe zeichnen und Kollision pruefen:
	For Local a% = 0 To count_Enemies
		Enemy[a].draw()
		If shuttle_death = False And Enemy[a].dead = False Then
			If ImagesCollide(shuttle, shuttle_column*ASCII_Size[0], shuttle_row*ASCII_Size[1],0, TEnemy.image[Enemy[a].shape], Enemy[a].column*ASCII_Size[0], Enemy[a].row*ASCII_Size[1],0) Then			
				PauseChannel(MusikChannel)
				Local ExplosionChannel:TChannel = PlaySound(Snd[2])
				SetChannelPan(ExplosionChannel, 2.0*Enemy[a].column/CountColumns - 1.0)
				PlaySound(Snd[3])
				Enemy[a].dead = True
				Enemy[a].explosion_time = ActualTime
				shuttle_death = True
				shuttle_explosion_nr = 0
				FlushKeys()   'wegen "KeyHit(KEY_ENTERN)" zum Neustart...
			End If
		End If					
	Next
	'----------------------------------------------------
	'Das Raumschiff und seine (simple) Steuerung:
	If shuttle_death = False Then
	'----------------------------------------------------
		DrawImage shuttle, ASCII_Size[0]*shuttle_column, ASCII_Size[1]*shuttle_row
		If KeyDown(KEY_LEFT) Then
			shuttle_column = shuttle_column - 1
			If shuttle_column >= 0 Then
				draw_shuttle_fire(1)
			Else
				shuttle_column = 0
			End If
		ElseIf KeyDown(KEY_RIGHT) Then
			shuttle_column = shuttle_column + 1
			If shuttle_column <= CountColumns+1 Then
				draw_shuttle_fire(2)
			Else
				shuttle_column = CountColumns+1
			End If
		End If
		If KeyDown(KEY_UP) Then
			shuttle_row = shuttle_row - 1
			If shuttle_row >= 0 Then
				draw_shuttle_fire(0)
			Else
				shuttle_row = 0
			End If
		ElseIf KeyDown(KEY_DOWN) Then
			shuttle_row = shuttle_row + 1
			If shuttle_row <= CountRows+1 Then
				draw_shuttle_fire(3)
			Else
				shuttle_row = CountRows+1
			End If
		End If
		'----------------------------------------------------
		'Das Schiessen:
		If KeyDown(KEY_SPACE) Then
			If ActualTime - shot_Time > wait_for_next_bullet Then
				Local i% = 0
				While Bullet[i] <> Null And i < CountRows/2 - 2
					i = i + 1
				Wend
				Bullet[i] = TBullet.build(shuttle_column-4, shuttle_row-4)
				Bullet[i+1] = TBullet.build(shuttle_column+4, shuttle_row-4)
				Local ShotChannel:TChannel = PlaySound(Snd[1])
				SetChannelPan(ShotChannel, 2.0*shuttle_column/CountColumns - 1.0)
				shot_Time = ActualTime
			End If
		End If
		'----------------------------------------------------
		'Die Geschosse und ihre Wirkung:
		For Local b% = 0 To CountRows/2
			If Bullet[b] <> Null Then
				Bullet[b].draw(b) 'Achtung: hier koennte = Null gesetzt werden, daher erneut fragen:
				If Bullet[b] <> Null Then
					'Erst wird jene Raumschiffbahn errechnet, deren Enemy getroffen werden koennte:				
					Local e% = 0
					Repeat
						If (Enemy[e].shape < 3 And Abs(Enemy[e].column - Bullet[b].column) < 4) Or (Enemy[e].shape = 3 And Abs(Enemy[e].column - Bullet[b].column) < 5) Then Exit
						e = e + 1
					Until e > count_enemies
					If e <= count_enemies Then
						If Enemy[e].shape <> 0 Then  'dieses Raumschiff laesst sich nicht zerstoeren!
							If Enemy[e].dead = False Then
							'Dann wird die Kollision mit diesem EINEN Raumschiff abgefragt:
								'If ImagesCollide(TBullet.image, Bullet[b].column*ASCII_Size[0], Bullet[b].row*ASCII_Size[1],0, TEnemy.image[Enemy[e].shape], Enemy[e].column*ASCII_Size[0], Enemy[e].row*ASCII_Size[1],0) Then						
								If Abs(Bullet[b].row - Enemy[e].row) < 3 Then
									Local ExplosionChannel:TChannel = PlaySound(Snd[2])
									SetChannelPan(ExplosionChannel, 2.0*Enemy[e].column/CountColumns - 1.0)
									Enemy[e].dead = True
									Enemy[e].explosion_time = ActualTime
									Select Enemy[e].shape
									Case 1
										Points = Points + 10
									Case 2
										Points = Points + 30
									Case 3   'Minuspunkte
										Points = Points - 40
									End Select
								End If
							End If
						End If
					End If
				End If
			End If
		Next
		'----------------------------------------------------
		DrawBlockedText(Points + " Punkte", 60*ASCII_Size[0], ScreenHeight - 2*ASCII_Size[1])
		'----------------------------------------------------
		If ChannelPlaying(MusikChannel) = False Then MusikChannel = PlaySound(Snd[0])
	'_____________________________________________________________________________________
	Else 'shuttle_death = True
		'----------------------------------------------------
		If shuttle_explosion_nr > -1 Then
			DrawImage explosion[shuttle_explosion_nr], shuttle_column*ASCII_Size[0], shuttle_row*ASCII_Size[1]
			shuttle_explosion_nr = shuttle_explosion_nr + 1
			If shuttle_explosion_nr = 10 Then shuttle_explosion_nr = -1
		End If
		'----------------------------------------------------
		If KeyHit(KEY_RETURN) Then
			If Points > Highscore Then Highscore = Points
			Points = 0
			shuttle_column% = CountColumns/2
			shuttle_row% = 3*CountRows/4
			shuttle_death = False
			shuttle_explosion_nr = -1
			For Local b% = 0 To CountRows/2
				Bullet[b] = Null
			Next
			For Local e% = 0 To count_Enemies
				Enemy[e].row = -Rand(2,CountColumns)
				Enemy[e].speed = Rand( 80 - Min(70, 70 * Max(0,Points) / 2000), 120 - Min(70, 70 * Max(0,Points) / 2000))
				Enemy[e].shape = Rand(0,3)
				Enemy[e].dead = False
				Enemy[e].explosion_nr = 0
			Next
			ResumeChannel(MusikChannel)
			FlushKeys()
		End If
		'----------------------------------------------------
		If Points > Highscore Then
			DrawBlockedText("Bravo!  Mit " + Points + " Punkten hast du einen neuen Highscore!", 34*ASCII_Size[0], CountRows/2*ASCII_Size[1])
			DrawBlockedText("Neustart mit Enter bzw. Return!", 46*ASCII_Size[0], (CountRows/2 + 3)*ASCII_Size[1])
		Else
			DrawBlockedText("Du hast " + Points + " Punkte erreicht!", 48*ASCII_Size[0], CountRows/2*ASCII_Size[1])
			DrawBlockedText("Neustart mit Enter bzw. Return!", 46*ASCII_Size[0], (CountRows/2 + 3)*ASCII_Size[1])
		End If
		'----------------------------------------------------
	End If
	'----------------------------------------------------
	Flip
	'----------------------------------------------------
	'Das Folgende hat nichts mehr mit dem eigentlichen Spiel bzw. Beitrag zu tun,
	'sondern dient lediglich zum "Einfrieren" des Screens als Extra-Service fuer das BlitzForum,
	'um sich zu JEDER Zeit ueber die Einhaltung aller Regeln ueberzeugen zu koennen:
	'Die Raster-Darstellung wird strikt eingehalten, an keiner Stelle liegen Zeichen ubereinander!
	If KeyDown(KEY_W) Then
		PauseChannel(MusikChannel)
		SetColor 64,64,128
		For Local r% = 0 To CountRows
			DrawRect 0, 1 + r*ASCII_Size[1], ScreenWidth, 1
		Next
		For Local c% = 0 To CountColumns
			DrawRect c*ASCII_Size[0], 0, 1, ScreenHeight
		Next
		Flip
		WaitKey()
		If shuttle_death = False Then ResumeChannel(MusikChannel)
	End If
	'----------------------------------------------------
	SetColor 255,255,255
Until KeyDown(KEY_ESCAPE)
'====================================================================================
End


'====================================================================================
'Functions:
'====================================================================================
Function create_ASCII_Image:TImage(filepath$, RGB%[])	   'by reading a textfile
	SetClsColor 0,0,0 '=> Transparenz an jenen Stellen des Bildes, an denen keine Zeichen stehen,
	Cls			 'ausserdem wird dadurch fuer Kollisionsgenauigkeit gesorgt.
	SetScale 1.0, 1.0
	Local Count%[2], Line$, file:TStream = ReadFile(filepath)
	While Not Eof(file)
		Line = ReadLine(file)
		Count[0] = Max(Count[0], Len(Line))
		'---------------------------------------------------------------------------------
		For Local i% = 0 To Len(Line)-1
			Local single_letter$ = Mid(Line, i+1, 1)
			If single_letter <> " " Then
				SetColor 255,255,255   'fr jedes Zeichen die nicht-transparente Unterlage:
				DrawImage RasterBlock, i * ASCII_Size[0], Count[1]*ASCII_Size[1]
				SetColor RGB[0], RGB[1], RGB[2]
				DrawText single_letter, i * ASCII_Size[0], Count[1]*ASCII_Size[1] - 1
			End If
		Next
		'---------------------------------------------------------------------------------
		Count[1] = Count[1] + 1
		'ein bisschen dunkler werden lassen, damit's nicht zu arg langweilig einfarbig wird:
		RGB = [19*RGB[0]/20, 19*RGB[1]/20, 19*RGB[2]/20]
	Wend
	CloseStream(file)
	'bei der Bildgroesse muss noch dafuer gesorgt werden, dass sie GERADZAHLIGEN Vielfachen des
	'Rasters entspricht, sonst wuerde sich das Bild wegen "MidHandleImage" nicht perfekt in das Raster einfuegen:
	If (Count[0]+1) / 2 <> Count[0] / 2 Then Count[0] = Count[0] + 1
	If (Count[1]+1) / 2 <> Count[1] / 2 Then Count[1] = Count[1] + 1
	'------------------------------------------------------------------------------------
	Local NewImage:TImage = CreateImage(Count[0]*ASCII_Size[0], Count[1]*ASCII_Size[1])
	GrabImage(NewImage, 0, 0)
	MidHandleImage(NewImage)
	Rem 'Extraservice, ums sich anzusehen, wie jedes einzelne Bild aussieht:
	SetClsColor 255,255,255
	Cls
	DrawImage NewImage, 0.5*Count[0]*ASCII_Size[0], 0.5*Count[1]*ASCII_Size[1]
	Flip
	WaitKey()
	End Rem
	Return NewImage
End Function
'====================================================================================
Function drawBlockedText(str$, x%, y%)
	SetColor 255,255,255
	For Local l% = 0 To Len(str)-1
		DrawImage RasterBlock, x+l*ASCII_Size[0], y
	Next
	DrawText str, x, y
End Function
'====================================================================================
Function draw_shuttle_fire(direction% = 0, start_column% = 0, start_row% = 0)	   'der Raketenantrieb:
	Select direction
	Case 0	   '(vorwaerts)
		DrawImage shuttle_fire[0], ASCII_Size[0]*shuttle_column, ASCII_Size[1]*(shuttle_row+5 + (shuttle_fire_step Mod 4))
		DrawImage shuttle_fire[1], ASCII_Size[0]*shuttle_column, ASCII_Size[1]*(shuttle_row+5 + ((shuttle_fire_step+1) Mod 4))
		DrawImage shuttle_fire[2], ASCII_Size[0]*shuttle_column, ASCII_Size[1]*(shuttle_row+5 + ((shuttle_fire_step+2) Mod 4))
		DrawImage shuttle_fire[3], ASCII_Size[0]*shuttle_column, ASCII_Size[1]*(shuttle_row+5 + ((shuttle_fire_step+3) Mod 4))
	Case 1	   '(nach Links)
		DrawImage shuttle_fire[0], ASCII_Size[0]*(shuttle_column+9+(shuttle_fire_step Mod 4)), ASCII_Size[1]*(shuttle_row+1)
		DrawImage shuttle_fire[1], ASCII_Size[0]*(shuttle_column+9+((shuttle_fire_step+1) Mod 4)), ASCII_Size[1]*(shuttle_row+1)
		DrawImage shuttle_fire[2], ASCII_Size[0]*(shuttle_column+9+((shuttle_fire_step+2) Mod 4)), ASCII_Size[1]*(shuttle_row+1)
		DrawImage shuttle_fire[3], ASCII_Size[0]*(shuttle_column+9+((shuttle_fire_step+3) Mod 4)), ASCII_Size[1]*(shuttle_row+1)
	Case 2	   '(nach Rechts)
		DrawImage shuttle_fire[0], ASCII_Size[0]*(shuttle_column-9-(shuttle_fire_step Mod 4)), ASCII_Size[1]*(shuttle_row+1)
		DrawImage shuttle_fire[1], ASCII_Size[0]*(shuttle_column-9-((shuttle_fire_step+1) Mod 4)), ASCII_Size[1]*(shuttle_row+1)
		DrawImage shuttle_fire[2], ASCII_Size[0]*(shuttle_column-9-((shuttle_fire_step+2) Mod 4)), ASCII_Size[1]*(shuttle_row+1)
		DrawImage shuttle_fire[3], ASCII_Size[0]*(shuttle_column-9-((shuttle_fire_step+3) Mod 4)), ASCII_Size[1]*(shuttle_row+1)
	Case 3	   '(Rueckwaerts)
		DrawImage shuttle_fire[0], ASCII_Size[0]*shuttle_column, ASCII_Size[1]*(shuttle_row-7 - (shuttle_fire_step Mod 4))
		DrawImage shuttle_fire[1], ASCII_Size[0]*shuttle_column, ASCII_Size[1]*(shuttle_row-7 - ((shuttle_fire_step+1) Mod 4))
		DrawImage shuttle_fire[2], ASCII_Size[0]*shuttle_column, ASCII_Size[1]*(shuttle_row-7 - ((shuttle_fire_step+2) Mod 4))
		DrawImage shuttle_fire[3], ASCII_Size[0]*shuttle_column, ASCII_Size[1]*(shuttle_row-7 - ((shuttle_fire_step+3) Mod 4))
	Case 4   'Rocketfire of the enemies:
		DrawImage shuttle_fire[2], ASCII_Size[0]*start_column, ASCII_Size[1]*(start_row - (shuttle_fire_step Mod 4))
		DrawImage shuttle_fire[3], ASCII_Size[0]*start_column, ASCII_Size[1]*(start_row - ((shuttle_fire_step+1) Mod 4))
		DrawImage shuttle_fire[0], ASCII_Size[0]*start_column, ASCII_Size[1]*(start_row - ((shuttle_fire_step+2) Mod 4))
		DrawImage shuttle_fire[1], ASCII_Size[0]*start_column, ASCII_Size[1]*(start_row - ((shuttle_fire_step+3) Mod 4))
	End Select
	If ActualTime-shuttle_fire_time > shuttle_fire_duration Then
		shuttle_fire_step = (shuttle_fire_step + 1) Mod 4
		shuttle_fire_time = ActualTime
	End If
End Function
'====================================================================================