Dim charset$(255)

charset(0) = " "
charset(1) = "."
charset(2) = ","
charset(3) = ":"
charset(4) = "`"
charset(5) = "'"
charset(6) = ";"
charset(7) = "^"
charset(8) = Chr(34)
charset(9) = "-"
charset(10) = "/"
charset(11) = "<"
charset(12) = ">"
charset(13) = "\"
charset(14) = "!"
charset(15) = "_"
charset(16) = "~"
charset(17) = "="
charset(18) = "("
charset(19) = ")"
charset(20) = "?"
charset(21) = "|"
charset(22) = "+"
charset(23) = "i"
charset(24) = "t"
charset(25) = "7"
charset(26) = "j"
charset(27) = "l"
charset(28) = "{"
charset(29) = "}"
charset(30) = "%"
charset(31) = "1"
charset(32) = "["
charset(33) = "]"
charset(34) = "v"
charset(35) = "2"
charset(36) = "3"
charset(37) = "J"
charset(38) = "c"
charset(39) = "f"
charset(40) = "r"
charset(41) = "$"
charset(42) = "C"
charset(43) = "I"
charset(44) = "u"
charset(45) = "6"
charset(46) = "9"
charset(47) = "o"
charset(48) = "w"
charset(49) = "y"
charset(50) = "z"
charset(51) = "5"
charset(52) = "T"
charset(53) = "a"
charset(54) = "n"
charset(55) = "s"
charset(56) = "&"
charset(57) = "0"
charset(58) = "4"
charset(59) = "L"
charset(60) = "O"
charset(61) = "V"
charset(62) = "Y"
charset(63) = "k"
charset(64) = "*"
charset(65) = "8"
charset(66) = "G"
charset(67) = "m"
charset(68) = "e"
charset(69) = "h"
charset(70) = "x"
charset(71) = "A"
charset(72) = "S"
charset(73) = "U"
charset(74) = "Z"
charset(75) = "b"
charset(76) = "d"
charset(77) = "g"
charset(78) = "p"
charset(79) = "q"
charset(80) = "D"
charset(81) = "F"
charset(82) = "P"
charset(83) = "Q"
charset(84) = "K"
charset(85) = "W"
charset(86) = "X"
charset(87) = "#"
charset(88) = "E"
charset(89) = "N"
charset(90) = "R"
charset(91) = "B"
charset(92) = "H"
charset(93) = "@"
charset(94) = "M"

Function ASCIIfi(camera, width = 64, height = 48)
	
	Local x, y
	Local rgb, r, g, b, bw
	Local output$[255]
	
	CameraViewport camera, 0, 0, width, height
	
	RenderWorld
	
	LockBuffer BackBuffer()
	
	For y = 0 To height
		For x = 0 To width
			rgb = ReadPixelFast(x, y, BackBuffer())
			
			r = (rgb And $FF0000) / $10000 
			g = (rgb And $FF00) / $100 
			b = rgb And $FF 
			
			bw = Int((r + g + b) / 3.0 * 94.0 / 255.0)
			
			output[y] = output[y] + charset$(bw)
			
		Next
	Next
	
	UnlockBuffer BackBuffer()
	
	Cls
	
	For y = 0 To height
		Text 0, y * 10, output[y]
	Next
	
End Function

;~IDEal Editor Parameters:
;~C#Blitz3D